package com.toplink.test;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.xml.datatype.XMLGregorianCalendar;

@Entity
@Table(name="tblUsers")
public class User {
	
	private Long id;
	private String loginName;
	private String password;
	private String firstName;
	private String lastName;
	private String email;
	private Date dateTimeStamp;
	
    public User() {
        
    }
    
    @Temporal(TemporalType.TIMESTAMP)
    public Date getDateTimeStamp() {
		return dateTimeStamp;
	}
	
	public void setDateTimeStamp(Date dateTimeStamp) {
		this.dateTimeStamp = dateTimeStamp;
	}
    
    @Transient
    public void setXmlDateTimeStamp(XMLGregorianCalendar xmlDateTimeStamp) {
        this.dateTimeStamp = xmlDateTimeStamp != null ? xmlDateTimeStamp.toGregorianCalendar().getTime()
                : null;        
    }
	
	public String getEmail() {
		return email;
	}
	
	public void setEmail(String email) {
		this.email = email;
	}
	
	public String getFirstName() {
		return firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	@Id
	@GeneratedValue
    public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	public String getLastName() {
		return lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	public String getLoginName() {
		return loginName;
	}
	
	public void setLoginName(String loginName) {
		this.loginName = loginName;
	}
	
	public String getPassword() {
		return password;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}

/*    @ManyToMany(fetch=FetchType.EAGER, targetEntity=com.pearson.pd.domain.Course.class)
    @JoinTable(name="tblEnrollment",
        joinColumns=
            @JoinColumn(name="UserId", referencedColumnName="ID"),
        inverseJoinColumns=
            @JoinColumn(name="CourseId", referencedColumnName="ID")
    )*/

    @Transient
    public String getDisplayName() {
        return firstName + " " + lastName;
    }

    @Override
    public int hashCode() {
        final int PRIME = 31;
        int result = 1;
        result = PRIME * result + ((loginName == null) ? 0 : loginName.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final User other = (User) obj;
        if (loginName == null) {
            if (other.loginName != null)
                return false;
        } else if (!loginName.equals(other.loginName))
            return false;
        return true;
    }
    
    
    
	
	
}
